//+------------------------------------------------------------------+
//|                                                       PT_SIG.mq4 |
//|                       Copyright 2009 , MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2009, PipeTrader."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Chartreuse
#property indicator_color2 Magenta
#property indicator_color3 White
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1

extern int count = 1000;
extern int MA_Period = 5; 

double sig_up[];
double sig_down[];
double sig_neutral[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
      SetIndexBuffer(0,sig_up);
      SetIndexBuffer(1,sig_down);
      SetIndexBuffer(2,sig_neutral);
      
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 233);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 234);  
      SetIndexStyle(2,DRAW_ARROW);
      SetIndexArrow(2, 251);  
      
      SetIndexEmptyValue(0,0.0);
      SetIndexEmptyValue(1,0.0);
  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//   int    counted_bars=IndicatorCounted();
//----
   
   double ha_open = 0.0;
   double ha_close = 0.0;
   double ha_high = 0.0;
   double ha_low = 0.0;
   
   double tdi_green = 0.0;
   double tdi_yellow = 0.0;
   
   double i_trend_green = 0.0;
   double i_trend_magenta = 0.0;
   
   
   for (int i = 0; i< count; i++){
      
      tdi_green = iCustom(NULL, 0, "Traders_Dynamic_Index", 4, i);
      tdi_yellow = iCustom(NULL, 0, "Traders_Dynamic_Index", 2, i);
   
      ha_open = iCustom(NULL, 0, "Heiken Ashi twinblade", 2, i);
      ha_close = iCustom(NULL, 0, "Heiken Ashi twinblade", 3, i);
      
      i_trend_green = iCustom(NULL, 0,"I_Trend", 0, i);
      i_trend_magenta = iCustom(NULL, 0,"I_Trend", 1, i);
      
      
      if (ha_open < ha_close){
         
         ha_high = iCustom(NULL, 0, "Heiken Ashi twinblade", 3, i);
         ha_low = iCustom(NULL, 0, "Heiken Ashi twinblade", 2, i);
         
         if ((ha_close >= iMA(NULL, 0, MA_Period , 0, MODE_SMMA, PRICE_LOW, i) - 1* Point )
          &&( i_trend_green > i_trend_magenta ) && ( tdi_green > tdi_yellow ) )
         {
            
            sig_up[i] = ha_low - 10* Point;
            
         }
          else sig_neutral[i] = ha_low + 10* Point;
      }
      else{
      
         ha_high = iCustom(NULL, 0, "Heiken Ashi twinblade", 2, i);
         ha_low = iCustom(NULL, 0, "Heiken Ashi twinblade", 3, i);
         
         if ((ha_close <= iMA(NULL, 0, MA_Period, 0, MODE_SMMA, PRICE_HIGH, i) + 1* Point)
           &&( i_trend_green < i_trend_magenta )  && ( tdi_green < tdi_yellow ) )
         {
            
            sig_down[i] = ha_open + 10* Point;
            
            
            
         }
         
         
         
         else sig_neutral[i] = ha_open + 10* Point;
         
      }
      
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+